# -*- coding: utf-8 -*-
"""
Created on Fri Apr  5 13:28:55 2024

@author: Juan
"""

#%%
import matplotlib

matplotlib.rcParams['xtick.minor.size'] = 3.5
matplotlib.rcParams['xtick.major.size'] = 5.0
matplotlib.rcParams['xtick.minor.width'] = 1.5
matplotlib.rcParams['xtick.major.width'] = 2.5
matplotlib.rcParams['xtick.direction'] = 'in'

matplotlib.rcParams['ytick.minor.size'] = 3.5
matplotlib.rcParams['ytick.major.size'] = 5.0
matplotlib.rcParams['ytick.minor.width'] = 1.5
matplotlib.rcParams['ytick.major.width'] = 2.5
matplotlib.rcParams['ytick.direction'] = 'in'

matplotlib.rcParams['axes.titlesize'] = 30#26
matplotlib.rcParams['axes.labelsize'] = 25
matplotlib.rcParams['axes.linewidth'] = 2#2.5

matplotlib.rcParams['font.family'] = 'Arial'
# matplotlib.rcParams['font.sans-serif'] = ['Tahoma']
matplotlib.rcParams['font.size'] = 25#18

matplotlib.rcParams['lines.linewidth'] = 3#2
matplotlib.rcParams['lines.markersize'] = 6

"""If you want to restart parameters:"""
# plt.rcdefaults()

#%%
VP = 3 # V
tP = 1e-6 # s
tf = 0.01 * tP # s
tL = 1e-7 # s = 100 ns
tPr = 5e-8 # s
tfr = 0.01 * tPr # s
sG.time = np.concatenate([np.linspace(0, tf, 11), np.linspace(tf+tP/10, tf+tP-tP/10, 9), np.linspace(tf+tP, tf+tP+tf, 11), np.linspace(tf+tP+tf+tPr/10, tf+tP+tf+tPr-tPr/10, 9)])
prevT = tf+tP+tf+tPr
sG.time = np.concatenate([sG.time, np.linspace(prevT, prevT + tfr, 11), np.linspace(prevT+tfr+tPr/10, prevT+tfr+tPr-tPr/10, 9), np.linspace(prevT+tfr+tPr, prevT+tfr+tPr+tfr, 11), np.linspace(prevT+tfr+tPr+tfr+tPr/10, prevT+tfr+tPr+tfr+tPr-tPr/10, 9)])
Vfg_vec = np.concatenate([np.linspace(0, VP, 11), VP*np.ones(9), np.linspace(VP, 0, 11), np.zeros(9)])
Vfg_vec = np.concatenate([Vfg_vec, np.linspace(0, -1, 11), -1*np.ones(9), np.linspace(-1, 0, 11), np.zeros(9)])
for tt in range(29):
    prevT = sG.time[-1] + tPr/10
    sG.time = np.concatenate([sG.time, np.linspace(prevT, prevT + tfr, 11), np.linspace(prevT+tfr+tPr/10, prevT+tfr+tPr-tPr/10, 9), np.linspace(prevT+tfr+tPr, prevT+tfr+tPr+tfr, 11), np.linspace(prevT+tfr+tPr+tfr+tPr/10, prevT+tfr+tPr+tfr+tPr-tPr/10, 9)])
    Vfg_vec = np.concatenate([Vfg_vec, np.linspace(0, -1, 11), -1*np.ones(9), np.linspace(-1, 0, 11), np.zeros(9)])
#end for
sG.deltaTime = np.append(sG.time[1] - sG.time[0], sG.time[1:] - sG.time[:-1])
Vd_vec = np.zeros(len(sG.time))
Vd_vec[Vfg_vec == -1] = -0.05
Vs_vec = np.zeros(len(sG.time))

outputDir = os.path.join(os.getcwd(), 'tP1mus_POS_pulses_Vd_WOtraps')

Jn_POS_1mus_pulses_WOtraps = np.zeros(len(Vfg_vec))
Jp_POS_1mus_pulses_WOtraps = np.zeros(len(Vfg_vec))
for tt in range(len(Vfg_vec)):
    Vfg = Vfg_vec[tt]
    Vd = Vd_vec[tt]
    Vs = Vs_vec[tt]
    fData = open(outputDir + (('\\Data_'+'%g_'*(len((Vfg, Vd, Vs))-1)+'%g_kk%03d.pkl') % (Vfg, Vd, Vs, tt)), 'rb')
    data1 = pickle.load(fData)
    fData.close()
    
    Jn_POS_1mus_pulses_WOtraps[tt] = np.dot(data1['S_Tr'].Jny[77,148:], sG.deltaLmid[148:,np.newaxis]) * 100 # A/cm ---> muA/mum
    Jp_POS_1mus_pulses_WOtraps[tt] = np.dot(data1['S_Tr'].Jpy[77,148:], sG.deltaLmid[148:,np.newaxis]) * 100 # A/cm ---> muA/mum
#end for
Vfg_vec_POS_WOtraps = Vfg_vec

###

VP = -3 # V
tP = 1e-6 # s
tf = 0.01 * tP # s
tL = 1e-7 # s = 100 ns
tPr = 5e-8 # s
tfr = 0.01 * tPr # s
sG.time = np.concatenate([np.linspace(0, tf, 11), np.linspace(tf+tP/10, tf+tP-tP/10, 9), np.linspace(tf+tP, tf+tP+tf, 11), np.linspace(tf+tP+tf+tPr/10, tf+tP+tf+tPr-tPr/10, 9)])
prevT = tf+tP+tf+tPr
sG.time = np.concatenate([sG.time, np.linspace(prevT, prevT + tfr, 11), np.linspace(prevT+tfr+tPr/10, prevT+tfr+tPr-tPr/10, 9), np.linspace(prevT+tfr+tPr, prevT+tfr+tPr+tfr, 11), np.linspace(prevT+tfr+tPr+tfr+tPr/10, prevT+tfr+tPr+tfr+tPr-tPr/10, 9)])
Vfg_vec = np.concatenate([np.linspace(0, VP, 11), VP*np.ones(9), np.linspace(VP, 0, 11), np.zeros(9)])
Vfg_vec = np.concatenate([Vfg_vec, np.linspace(0, -1, 11), -1*np.ones(9), np.linspace(-1, 0, 11), np.zeros(9)])
for tt in range(29):
    prevT = sG.time[-1] + tPr/10
    sG.time = np.concatenate([sG.time, np.linspace(prevT, prevT + tfr, 11), np.linspace(prevT+tfr+tPr/10, prevT+tfr+tPr-tPr/10, 9), np.linspace(prevT+tfr+tPr, prevT+tfr+tPr+tfr, 11), np.linspace(prevT+tfr+tPr+tfr+tPr/10, prevT+tfr+tPr+tfr+tPr-tPr/10, 9)])
    Vfg_vec = np.concatenate([Vfg_vec, np.linspace(0, -1, 11), -1*np.ones(9), np.linspace(-1, 0, 11), np.zeros(9)])
#end for
sG.deltaTime = np.append(sG.time[1] - sG.time[0], sG.time[1:] - sG.time[:-1])
Vd_vec = np.zeros(len(sG.time))
Vd_vec[Vfg_vec == -1] = -0.05
Vs_vec = np.zeros(len(sG.time))

outputDir = os.path.join(os.getcwd(), 'tP1mus_NEG_pulses_Vd_WOtraps')

Jn_NEG_1mus_pulses_WOtraps = np.zeros(len(Vfg_vec))
Jp_NEG_1mus_pulses_WOtraps = np.zeros(len(Vfg_vec))
for tt in range(len(Vfg_vec)):
    Vfg = Vfg_vec[tt]
    Vd = Vd_vec[tt]
    Vs = Vs_vec[tt]
    fData = open(outputDir + (('\\Data_'+'%g_'*(len((Vfg, Vd, Vs))-1)+'%g_kk%03d.pkl') % (Vfg, Vd, Vs, tt)), 'rb')
    data1 = pickle.load(fData)
    fData.close()
    
    Jn_NEG_1mus_pulses_WOtraps[tt] = np.dot(data1['S_Tr'].Jny[77,148:], sG.deltaLmid[148:,np.newaxis]) * 100 # A/cm ---> muA/mum
    Jp_NEG_1mus_pulses_WOtraps[tt] = np.dot(data1['S_Tr'].Jpy[77,148:], sG.deltaLmid[148:,np.newaxis]) * 100 # A/cm ---> muA/mum
#end for
Vfg_vec_NEG_WOtraps = Vfg_vec

#%%
"""DATA"""
np.savetxt('Vfg_POS.txt', Vfg_vec_POS_WOtraps)
np.savetxt('Vfg_NEG.txt', Vfg_vec_NEG_WOtraps)
np.savetxt('Ids_POS.txt', Jn_POS_1mus_pulses_WOtraps + Jp_POS_1mus_pulses_WOtraps)
np.savetxt('Ids_NEG.txt', Jn_NEG_1mus_pulses_WOtraps + Jp_NEG_1mus_pulses_WOtraps)

#%% Same graph, less points
list_points = [0, 10, 20]
for kk in range(int((len(sG.time)-30)/10)):
    list_points.append(30+kk*10)
#end for

list_pointsV = list_points.copy()
addlist = [-1, 1]
for kk in range(1,len(list_pointsV)):
    list_pointsV[kk] += addlist[kk%2]
#end for

fig, (ax1, ax2) = plt.subplots(2,1, sharex=False)
ax1.plot(sG.time[list_points]*1e6, Vfg_vec_NEG_WOtraps[list_points], 'b-')
ax1.plot(sG.time[list_points[:4]]*1e6, Vfg_vec_POS_WOtraps[list_points[:4]], 'r-')
ax1.plot(sG.time[list_points[3:]]*1e6, Vfg_vec_POS_WOtraps[list_points[3:]], 'r--')
ax2.plot(sG.time[list_pointsV]*1e6, Jn_NEG_1mus_pulses_WOtraps[list_pointsV] + Jp_NEG_1mus_pulses_WOtraps[list_pointsV], 'b-')
ax2.plot(sG.time[list_pointsV]*1e6, Jn_POS_1mus_pulses_WOtraps[list_pointsV] + Jp_POS_1mus_pulses_WOtraps[list_pointsV], 'r-')
# ax1.set_xlabel('$t$ ($\mu$s)')
ax1.set_ylabel('$\mathregular{V_{gs}}$ (V)')
ax1.grid(True)
ax1.set_title('$\mathregular{V_P = +3}$ V, $\mathregular{t_w = 1}$ $\mathregular{\mu}$s')
ax2.set_xlabel('t ($\mu$s)')
ax2.set_ylabel('$\mathregular{I_{ds}}$ ($\mathregular{\mu}$A/$\mathregular{\mu}$m)')
ax2.grid(True)
# ax1.set_xlabel('$t$ ($\mu$s)')
ax1.set_ylabel('$\mathregular{V_{gs}}$ (V)')
ax1.grid(True)
ax1.set_title('$\mathregular{t_w = 1}$ $\mathregular{\mu}$s')