# -*- coding: utf-8 -*-
"""
Created on Fri Apr  5 13:48:57 2024

@author: Juan
"""

import os
import pickle
import numpy as np
import cv2
import matplotlib.pyplot as plt
import scipy.constants as cnst
import scipy.io as sio

import tikzplotlib

from matplotlib.image import NonUniformImage
from matplotlib import cm

import matplotlib
matplotlib.rcParams.update({'font.size': 15})

#%% #???
"""Retention time
After applying the writing pulse of duration tW,
ion concentration was measured every 1 mus during 1ms."""

"""t_P = 100ns"""
VP = 3 # V
tP = 1e-7 # s
tf = 0.01 * tP # s
tL = 1e-7 # s = 100 ns
time = np.concatenate([np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-6, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-5, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-4, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-3, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-2, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-1, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e0, \
                       np.logspace(1e-6, 1e0, 10, endpoint=True)*1e1])
sG.time = np.concatenate([np.linspace(0, tf, 11), np.linspace(tf+tP/10, tf+tP-tP/10, 9), np.linspace(tf+tP, tf+tP+tf, 11), tf+tP+tf + time])
sG.deltaTime = np.append(sG.time[1] - sG.time[0], sG.time[1:] - sG.time[:-1])
Vfg_vec = np.concatenate([np.linspace(0, VP, 11), VP*np.ones(9), np.linspace(VP, 0, 11), np.zeros(len(time))])
Vd_vec = -0.05 * np.ones(len(sG.time))
Vs_vec = np.zeros(len(sG.time))

outputDir = os.path.join(os.getcwd(), 'simulations', 'tP100ns_POS_off_1ms_WOtraps_J_new')

time_100ns = sG.time.copy()
Jn_100ns = np.zeros(len(sG.time))
Jp_100ns = np.zeros(len(sG.time))
for tt in range(len(sG.time)):
    Vfg = Vfg_vec[tt]
    Vd = Vd_vec[tt]
    Vs = Vs_vec[tt]
    fData = open(outputDir + (('\\Data_'+'%g_'*(len((Vfg, Vd, Vs))-1)+'%g_kk%03d.pkl') % (Vfg, Vd, Vs, tt)), 'rb')
    data1 = pickle.load(fData)
    fData.close()
    Jn_100ns[tt] = np.dot(data1['S_Tr'].Jny[77,148:], sG.deltaLmid[148:,np.newaxis]) * 100 # A/cm ---> muA/mum
    Jp_100ns[tt] = np.dot(data1['S_Tr'].Jpy[77,148:], sG.deltaLmid[148:,np.newaxis]) * 100 # A/cm ---> muA/mum
#end for

"""t_P = 200ns"""
VP = 3 # V
tP = 2e-7 # s
tf = 0.01 * tP # s
tL = 1e-7 # s = 100 ns
time = np.concatenate([np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-6, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-5, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-4, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-3, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-2, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-1, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e0, \
                       np.logspace(1e-6, 1e0, 10, endpoint=True)*1e1])
sG.time = np.concatenate([np.linspace(0, tf, 11), np.linspace(tf+tP/10, tf+tP-tP/10, 9), np.linspace(tf+tP, tf+tP+tf, 11), tf+tP+tf + time])
sG.deltaTime = np.append(sG.time[1] - sG.time[0], sG.time[1:] - sG.time[:-1])
Vfg_vec = np.concatenate([np.linspace(0, VP, 11), VP*np.ones(9), np.linspace(VP, 0, 11), np.zeros(len(time))])
Vd_vec = -0.05 * np.ones(len(sG.time))
Vs_vec = np.zeros(len(sG.time))

outputDir = os.path.join(os.getcwd(), 'simulations', 'tP200ns_POS_off_1ms_WOtraps_J_new')

time_200ns = sG.time.copy()
Jn_200ns = np.zeros(len(sG.time))
Jp_200ns = np.zeros(len(sG.time))
for tt in range(len(sG.time)):
    Vfg = Vfg_vec[tt]
    Vd = Vd_vec[tt]
    Vs = Vs_vec[tt]
    fData = open(outputDir + (('\\Data_'+'%g_'*(len((Vfg, Vd, Vs))-1)+'%g_kk%03d.pkl') % (Vfg, Vd, Vs, tt)), 'rb')
    data1 = pickle.load(fData)
    fData.close()
    Jn_200ns[tt] = np.dot(data1['S_Tr'].Jny[77,148:], sG.deltaLmid[148:,np.newaxis]) * 100 # A/cm ---> muA/mum
    Jp_200ns[tt] = np.dot(data1['S_Tr'].Jpy[77,148:], sG.deltaLmid[148:,np.newaxis]) * 100 # A/cm ---> muA/mum
#end for

"""t_P = 500ns"""
VP = 3 # V
tP = 5e-7 # s
tf = 0.01 * tP # s
tL = 1e-7 # s = 100 ns
time = np.concatenate([np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-6, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-5, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-4, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-3, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-2, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-1, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e0, \
                       np.logspace(1e-6, 1e0, 10, endpoint=True)*1e1])
sG.time = np.concatenate([np.linspace(0, tf, 11), np.linspace(tf+tP/10, tf+tP-tP/10, 9), np.linspace(tf+tP, tf+tP+tf, 11), tf+tP+tf + time])
sG.deltaTime = np.append(sG.time[1] - sG.time[0], sG.time[1:] - sG.time[:-1])
Vfg_vec = np.concatenate([np.linspace(0, VP, 11), VP*np.ones(9), np.linspace(VP, 0, 11), np.zeros(len(time))])
Vd_vec = -0.05 * np.ones(len(sG.time))
Vs_vec = np.zeros(len(sG.time))

outputDir = os.path.join(os.getcwd(), 'simulations', 'tP500ns_POS_off_1ms_WOtraps_J_new')

time_500ns = sG.time.copy()
Jn_500ns = np.zeros(len(sG.time))
Jp_500ns = np.zeros(len(sG.time))
for tt in range(len(sG.time)):
    Vfg = Vfg_vec[tt]
    Vd = Vd_vec[tt]
    Vs = Vs_vec[tt]
    fData = open(outputDir + (('\\Data_'+'%g_'*(len((Vfg, Vd, Vs))-1)+'%g_kk%03d.pkl') % (Vfg, Vd, Vs, tt)), 'rb')
    data1 = pickle.load(fData)
    fData.close()
    Jn_500ns[tt] = np.dot(data1['S_Tr'].Jny[77,148:], sG.deltaLmid[148:,np.newaxis]) * 100 # A/cm ---> muA/mum
    Jp_500ns[tt] = np.dot(data1['S_Tr'].Jpy[77,148:], sG.deltaLmid[148:,np.newaxis]) * 100 # A/cm ---> muA/mum
#end for

"""t_P = 1mus"""
VP = 3 # V
tP = 1e-6 # s
tf = 0.01 * tP # s
tL = 1e-7 # s = 100 ns
time = np.concatenate([np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-6, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-5, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-4, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-3, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-2, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-1, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e0, \
                       np.logspace(1e-6, 1e0, 10, endpoint=True)*1e1])
sG.time = np.concatenate([np.linspace(0, tf, 11), np.linspace(tf+tP/10, tf+tP-tP/10, 9), np.linspace(tf+tP, tf+tP+tf, 11), tf+tP+tf + time])
sG.deltaTime = np.append(sG.time[1] - sG.time[0], sG.time[1:] - sG.time[:-1])
Vfg_vec = np.concatenate([np.linspace(0, VP, 11), VP*np.ones(9), np.linspace(VP, 0, 11), np.zeros(len(time))])
Vd_vec = -0.05 * np.ones(len(sG.time))
Vs_vec = np.zeros(len(sG.time))

outputDir = os.path.join(os.getcwd(), 'simulations', 'tP1mus_POS_off_1ms_WOtraps_J_new')

time_1mus = sG.time.copy()
Jn_1mus = np.zeros(len(sG.time))
Jp_1mus = np.zeros(len(sG.time))
for tt in range(len(sG.time)):
    Vfg = Vfg_vec[tt]
    Vd = Vd_vec[tt]
    Vs = Vs_vec[tt]
    fData = open(outputDir + (('\\Data_'+'%g_'*(len((Vfg, Vd, Vs))-1)+'%g_kk%03d.pkl') % (Vfg, Vd, Vs, tt)), 'rb')
    data1 = pickle.load(fData)
    fData.close()
    Jn_1mus[tt] = np.dot(data1['S_Tr'].Jny[77,148:], sG.deltaLmid[148:,np.newaxis]) * 100 # A/cm ---> muA/mum
    Jp_1mus[tt] = np.dot(data1['S_Tr'].Jpy[77,148:], sG.deltaLmid[148:,np.newaxis]) * 100 # A/cm ---> muA/mum
#end for

"""t_P = 2mus"""
VP = 3 # V
tP = 2e-6 # s
tf = 0.01 * tP # s
tL = 1e-7 # s = 100 ns
time = np.concatenate([np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-6, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-5, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-4, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-3, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-2, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-1, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e0, \
                       np.logspace(1e-6, 1e0, 10, endpoint=True)*1e1])
sG.time = np.concatenate([np.linspace(0, tf, 11), np.linspace(tf+tP/10, tf+tP-tP/10, 9), np.linspace(tf+tP, tf+tP+tf, 11), tf+tP+tf + time])
sG.deltaTime = np.append(sG.time[1] - sG.time[0], sG.time[1:] - sG.time[:-1])
Vfg_vec = np.concatenate([np.linspace(0, VP, 11), VP*np.ones(9), np.linspace(VP, 0, 11), np.zeros(len(time))])
Vd_vec = -0.05 * np.ones(len(sG.time))
Vs_vec = np.zeros(len(sG.time))

outputDir = os.path.join(os.getcwd(), 'simulations', 'tP2mus_POS_off_1ms_WOtraps_J_new')

time_2mus = sG.time.copy()
Jn_2mus = np.zeros(len(sG.time))
Jp_2mus = np.zeros(len(sG.time))
for tt in range(len(sG.time)):
    Vfg = Vfg_vec[tt]
    Vd = Vd_vec[tt]
    Vs = Vs_vec[tt]
    fData = open(outputDir + (('\\Data_'+'%g_'*(len((Vfg, Vd, Vs))-1)+'%g_kk%03d.pkl') % (Vfg, Vd, Vs, tt)), 'rb')
    data1 = pickle.load(fData)
    fData.close()
    Jn_2mus[tt] = np.dot(data1['S_Tr'].Jny[77,148:], sG.deltaLmid[148:,np.newaxis]) * 100 # A/cm ---> muA/mum
    Jp_2mus[tt] = np.dot(data1['S_Tr'].Jpy[77,148:], sG.deltaLmid[148:,np.newaxis]) * 100 # A/cm ---> muA/mum
#end for

"""t_P = 5mus"""
VP = 3 # V
tP = 5e-6 # s
tf = 0.01 * tP # s
tL = 1e-7 # s = 100 ns
time = np.concatenate([np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-6, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-5, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-4, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-3, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-2, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-1, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e0, \
                       np.logspace(1e-6, 1e0, 10, endpoint=True)*1e1])
sG.time = np.concatenate([np.linspace(0, tf, 11), np.linspace(tf+tP/10, tf+tP-tP/10, 9), np.linspace(tf+tP, tf+tP+tf, 11), tf+tP+tf + time])
sG.deltaTime = np.append(sG.time[1] - sG.time[0], sG.time[1:] - sG.time[:-1])
Vfg_vec = np.concatenate([np.linspace(0, VP, 11), VP*np.ones(9), np.linspace(VP, 0, 11), np.zeros(len(time))])
Vd_vec = -0.05 * np.ones(len(sG.time))
Vs_vec = np.zeros(len(sG.time))

outputDir = os.path.join(os.getcwd(), 'simulations', 'tP5mus_POS_off_1ms_WOtraps_J_new')

time_5mus = sG.time.copy()
Jn_5mus = np.zeros(len(sG.time))
Jp_5mus = np.zeros(len(sG.time))
for tt in range(len(sG.time)):
    Vfg = Vfg_vec[tt]
    Vd = Vd_vec[tt]
    Vs = Vs_vec[tt]
    fData = open(outputDir + (('\\Data_'+'%g_'*(len((Vfg, Vd, Vs))-1)+'%g_kk%03d.pkl') % (Vfg, Vd, Vs, tt)), 'rb')
    data1 = pickle.load(fData)
    fData.close()
    Jn_5mus[tt] = np.dot(data1['S_Tr'].Jny[77,148:], sG.deltaLmid[148:,np.newaxis]) * 100 # A/cm ---> muA/mum
    Jp_5mus[tt] = np.dot(data1['S_Tr'].Jpy[77,148:], sG.deltaLmid[148:,np.newaxis]) * 100 # A/cm ---> muA/mum
#end for

"""t_P = 10mus"""
VP = 3 # V
tP = 1e-5 # s
tf = 0.01 * tP # s
tL = 1e-7 # s = 100 ns
time = np.concatenate([np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-6, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-5, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-4, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-3, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-2, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e-1, \
                       np.logspace(1e-6, 1e0, 9, endpoint=False)*1e0, \
                       np.logspace(1e-6, 1e0, 10, endpoint=True)*1e1])
sG.time = np.concatenate([np.linspace(0, tf, 11), np.linspace(tf+tP/10, tf+tP-tP/10, 9), np.linspace(tf+tP, tf+tP+tf, 11), tf+tP+tf + time])
sG.deltaTime = np.append(sG.time[1] - sG.time[0], sG.time[1:] - sG.time[:-1])
Vfg_vec = np.concatenate([np.linspace(0, VP, 11), VP*np.ones(9), np.linspace(VP, 0, 11), np.zeros(len(time))])
Vd_vec = -0.05 * np.ones(len(sG.time))
Vs_vec = np.zeros(len(sG.time))

outputDir = os.path.join(os.getcwd(), 'simulations', 'tP10mus_POS_off_1ms_WOtraps_J_new')

time_10mus = sG.time.copy()
Jn_10mus = np.zeros(len(sG.time))
Jp_10mus = np.zeros(len(sG.time))
for tt in range(len(sG.time)):
    Vfg = Vfg_vec[tt]
    Vd = Vd_vec[tt]
    Vs = Vs_vec[tt]
    fData = open(outputDir + (('\\Data_'+'%g_'*(len((Vfg, Vd, Vs))-1)+'%g_kk%03d.pkl') % (Vfg, Vd, Vs, tt)), 'rb')
    data1 = pickle.load(fData)
    fData.close()
    Jn_10mus[tt] = np.dot(data1['S_Tr'].Jny[77,148:], sG.deltaLmid[148:,np.newaxis]) * 100 # A/cm ---> muA/mum
    Jp_10mus[tt] = np.dot(data1['S_Tr'].Jpy[77,148:], sG.deltaLmid[148:,np.newaxis]) * 100 # A/cm ---> muA/mum
#end for

#%%
"""DATA"""
J_100ns = (Jn_100ns + Jp_100ns)
J_200ns = (Jn_200ns + Jp_200ns)
J_500ns = (Jn_500ns + Jp_500ns)
J_1mus = (Jn_1mus + Jp_1mus)
J_2mus = (Jn_2mus + Jp_2mus)
J_5mus = (Jn_5mus + Jp_5mus)
J_10mus = (Jn_10mus + Jp_10mus)


#%%
"""Current same timescale"""
fig = plt.figure()
plt.plot(sG.time[31:]*1e6, J_100ns[31:], label='$t_w = 100$ ns')
plt.plot(sG.time[31:]*1e6, J_200ns[31:], label='$t_w = 200$ ns')
plt.plot(sG.time[31:]*1e6, J_500ns[31:], label='$t_w = 500$ ns')
plt.plot(sG.time[31:]*1e6, J_1mus[31:], label='$t_w = 1$ $\mathregular{\mu}$s')
plt.plot(sG.time[31:]*1e6, J_2mus[31:], label='$t_w = 2$ $\mathregular{\mu}$s')
plt.plot(sG.time[31:]*1e6, J_5mus[31:], label='$t_w = 5$ $\mathregular{\mu}$s')
plt.plot(sG.time[31:]*1e6, J_10mus[31:], label='$t_w = 10$ $\mathregular{\mu}$s')
plt.xlabel('time ($\mathregular{\mu}$s)')
plt.ylabel('$\mathregular{I_{ds}}$ ($\mathregular{\mu}$A/$\mathregular{\mu}$m)')
plt.xscale('log')
plt.yscale('log')
plt.grid(True)
plt.legend()

###

Jrange = np.zeros(7)
Jrange[0] = J_100ns[31] - J_100ns[-1]
Jrange[1] = J_200ns[31] - J_200ns[-1]
Jrange[2] = J_500ns[31] - J_500ns[-1]
Jrange[3] = J_1mus[31] - J_1mus[-1]
Jrange[4] = J_2mus[31] - J_2mus[-1]
Jrange[5] = J_5mus[31] - J_5mus[-1]
Jrange[6] = J_10mus[31] - J_10mus[-1]

def tret(limit, Jrel, time):
    idx = np.argmin(np.abs(Jrel - limit))
    
    if (Jrel[idx] > limit):
        idxx = idx+1
        tret = time[idx] - (limit - Jrel[idx]) * (time[idxx] - time[idx]) / (Jrel[idxx] - Jrel[idx])
    else:
        idxx = idx-1
        tret = time[idxx] - (limit - Jrel[idxx]) * (time[idx] - time[idxx]) / (Jrel[idx] - Jrel[idxx])
    #end if
    
    return tret
#end def

fig = plt.figure()
t_W = np.array([0.1, 0.2, 0.5, 1, 2, 5, 10])
limit = 0.01

t_ret = np.zeros(7)
t_ret[0] = tret(limit * Jrange[0] + J_100ns[-1], J_100ns[31:], sG.time[31:])*1e6 - sG.time[31]*1e6
t_ret[1] = tret(limit * Jrange[1] + J_200ns[-1], J_200ns[31:], sG.time[31:])*1e6 - sG.time[31]*1e6
t_ret[2] = tret(limit * Jrange[2] + J_500ns[-1], J_500ns[31:], sG.time[31:])*1e6 - sG.time[31]*1e6
t_ret[3] = tret(limit * Jrange[3] + J_1mus[-1], J_1mus[31:], sG.time[31:])*1e6 - sG.time[31]*1e6
t_ret[4] = tret(limit * Jrange[4] + J_2mus[-1], J_2mus[31:], sG.time[31:])*1e6 - sG.time[31]*1e6
t_ret[5] = tret(limit * Jrange[5] + J_5mus[-1], J_5mus[31:], sG.time[31:])*1e6 - sG.time[31]*1e6
t_ret[6] = tret(limit * Jrange[6] + J_10mus[-1], J_10mus[31:], sG.time[31:])*1e6 - sG.time[31]*1e6
    
plt.plot(t_W, t_ret, '-*', label='1 %')
plt.xlabel('$\mathregular{t_{w}}$ ($\mathregular{\mu}$s)')
plt.xscale('log')
plt.ylabel('$\mathregular{t_{ret}}$ ($\mathregular{\mu}$s)')
plt.grid(True)
plt.legend()
plt.yscale('log')